regina::NMatrixInt Class Reference
Mathematical Support

Represents a matrix of arbitrary precision integers. More...

`#include <maths/nmatrixint.h>`

Inheritance diagram for regina::NMatrixInt:

## Public Member Functions

| NMatrixInt (unsigned long rows, unsigned long cols)
| Creates a new matrix of the given size. More...
| NMatrixInt (const NMatrixInt &cloneMe)
| Creates a new matrix that is a clone of the given matrix. More...
void | divRowExact (unsigned long row, const NLargeInteger &divBy)
| Divides all elements of the given row by the given integer. More...
void | divColExact (unsigned long col, const NLargeInteger &divBy)
| Divides all elements of the given column by the given integer. More...
NLargeInteger | gcdRow (unsigned long row)
| Computes the greatest common divisor of all elements of the given row. More...
NLargeInteger | gcdCol (unsigned long col)
| Computes the greatest common divisor of all elements of the given column. More...
void | reduceRow (unsigned long row)
| Reduces the given row by dividing all its elements by their greatest common divisor. More...
void | reduceCol (unsigned long col)
| Reduces the given column by dividing all its elements by their greatest common divisor. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NMatrixRing< NLargeInteger >
| NMatrixRing (unsigned long rows, unsigned long cols)
| Creates a new matrix of the given size. More...
| NMatrixRing (const NMatrix< NLargeInteger > &cloneMe)
| Creates a new matrix that is a clone of the given matrix. More...
void | makeIdentity ()
| Turns this matrix into an identity matrix. More...
bool | isIdentity () const
| Determines whether this matrix is a square identity matrix. More...
bool | isZero () const
| Determines whether this is the zero matrix. More...
void | addRow (unsigned long source, unsigned long dest)
| Adds the given source row to the given destination row. More...
void | addRow (unsigned long source, unsigned long dest, NLargeIntegercopies)
| Adds the given number of copies of the given source row to the given destination row. More...
void | addCol (unsigned long source, unsigned long dest)
| Adds the given source column to the given destination column. More...
void | addCol (unsigned long source, unsigned long dest, NLargeIntegercopies)
| Adds the given number of copies of the given source column to the given destination column. More...
void | multRow (unsigned long row, NLargeIntegerfactor)
| Multiplies the given row by the given factor. More...
void | multCol (unsigned long column, NLargeIntegerfactor)
| Multiplies the given column by the given factor. More...
std::auto_ptr< NMatrixRing < NLargeInteger > > | operator* (const NMatrixRing< NLargeInteger > &other) const
| Multiplies this by the given matrix, and returns the result. More...
std::auto_ptr< MatrixClass > | multiplyAs (const NMatrixRing< NLargeInteger > &other) const
| Multiplies this by the given matrix, and returns a new matrix of subclass MatrixClass. More...
NLargeInteger | det () const
| Evaluates the determinant of the matrix. More...
Public Member Functions inherited from regina::NMatrix< NLargeInteger >
| NMatrix (unsigned long rows, unsigned long cols)
| Creates a new matrix of the given size. More...
| NMatrix (const NMatrix &cloneMe)
| Creates a new matrix that is a clone of the given matrix. More...
virtual | ~NMatrix ()
| Destroys this matrix. More...
void | initialise (const NLargeInteger &value)
| Sets every entry in the matrix to the given value. More...
void | initialise (List allValues)
| A Python-only routine that fills the matrix with the given set of elements. More...
unsigned long | rows () const
| Returns the number of rows in this matrix. More...
unsigned long | columns () const
| Returns the number of columns in this matrix. More...
NLargeInteger & | entry (unsigned long row, unsigned long column)
| Returns the entry at the given row and column. More...
const NLargeInteger & | entry (unsigned long row, unsigned long column) const
| Returns the entry at the given row and column. More...
bool | operator== (const NMatrix< NLargeInteger > &other) const
| Determines whether this and the given matrix are identical. More...
bool | operator!= (const NMatrix< NLargeInteger > &other) const
| Determines whether this and the given matrix are different. More...
virtual void | writeMatrix (std::ostream &out) const
| Writes a complete representation of the matrix to the given output stream. More...
void | swapRows (unsigned long first, unsigned long second)
| Swaps the elements of the two given rows in the matrix. More...
void | swapColumns (unsigned long first, unsigned long second)
| Swaps the elements of the two given columns in the matrix. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Additional Inherited Members

Static Public Attributes inherited from regina::NMatrixRing< NLargeInteger >
static NLargeInteger | zero
| Zero in the underlying ring. More...
static NLargeInteger | one
| One (the multiplicative identity) in the underlying ring. More...
Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...
Protected Attributes inherited from regina::NMatrix< NLargeInteger >
unsigned long | nRows
| The number of rows in the matrix. More...
unsigned long | nCols
| The number of columns in the matrix. More...
NLargeInteger ** | data
| The actual entries in the matrix. More...

## Detailed Description

Represents a matrix of arbitrary precision integers.

Calculations will be exact no matter how large the integers become.

Note that many important functions (such as entry()) are inherited from the superclasses NMatrix and NMatrixRing, and are not documented again here. Many other algorithms that work on the NMatrixInt class are available in the maths/matrixops.h file.

Python:
  Most inherited member functions are implemented. Exceptions are noted in the documentation for each individual member function.

## Member Function Documentation

void regina::NMatrixInt::divColExact | ( | unsigned long | col,
|  | const NLargeInteger & | divBy
| ) |  |

inline

Divides all elements of the given column by the given integer.

This can only be used when the given integer divides into all column elements exactly (with no remainder), and is much faster than ordinary division.

Precondition
  The argument divBy is neither zero nor infinity, and none of the elements of the given column are infinity.
  The argument divBy divides exactly into every element of the given column (i.e., it leaves no remainder).
  The given column number is between 0 and columns()-1 inclusive.

Parameters

  col | the index of the column whose elements should be divided by divBy.
  divBy | the integer to divide each column element by.

void regina::NMatrixInt::divRowExact | ( | unsigned long | row,
|  | const NLargeInteger & | divBy
| ) |  |

inline

Divides all elements of the given row by the given integer.

This can only be used when the given integer divides into all row elements exactly (with no remainder), and is much faster than ordinary division.

Precondition
  The argument divBy is neither zero nor infinity, and none of the elements of the given row are infinity.
  The argument divBy divides exactly into every element of the given row (i.e., it leaves no remainder).
  The given row number is between 0 and rows()-1 inclusive.

Parameters

  row | the index of the row whose elements should be divided by divBy.
  divBy | the integer to divide each row element by.

NLargeInteger regina::NMatrixInt::gcdCol | ( | unsigned long | col | ) |

inline

Computes the greatest common divisor of all elements of the given column.

The value returned is guaranteed to be non-negative.

Precondition
  The given column number is between 0 and columns()-1 inclusive.

Parameters

  col | the index of the column whose gcd should be computed.

Returns
  the greatest common divisor of all elements of this column.

NLargeInteger regina::NMatrixInt::gcdRow | ( | unsigned long | row | ) |

inline

Computes the greatest common divisor of all elements of the given row.

The value returned is guaranteed to be non-negative.

Precondition
  The given row number is between 0 and rows()-1 inclusive.

Parameters

  row | the index of the row whose gcd should be computed.

Returns
  the greatest common divisor of all elements of this row.

void regina::NMatrixInt::reduceCol | ( | unsigned long | col | ) |

inline

Reduces the given column by dividing all its elements by their greatest common divisor.

It is guaranteed that, if the column is changed at all, it will be divided by a positive integer.

Precondition
  The given column number is between 0 and columns()-1 inclusive.

Parameters

  col | the index of the column to reduce.

void regina::NMatrixInt::reduceRow | ( | unsigned long | row | ) |

inline

Reduces the given row by dividing all its elements by their greatest common divisor.

It is guaranteed that, if the row is changed at all, it will be divided by a positive integer.

Precondition
  The given row number is between 0 and rows()-1 inclusive.

Parameters

  row | the index of the row to reduce.

The documentation for this class was generated from the following file:

- maths/nmatrixint.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).